/*
***** BEGIN LICENSE BLOCK *****
Version: MPL 1.1/GPL 2.0/LGPL 2.1

The contents of this file are subject to the Mozilla Public License Version 
1.1 (the "License"); you may not use this file except in compliance with 
the License. You may obtain a copy of the License at 
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is Show Image, an extension for Mozilla Firefox.

The Initial Developer of the Original Code is
Lim Cheng Khoon.
Portions created by the Initial Developer are Copyright (C) 2005
the Initial Developer. All Rights Reserved.

Contributor(s):
  Lim Cheng Khoon (chengkhoon@gmail.com)

Alternatively, the contents of this file may be used under the terms of
either the GNU General Public License Version 2 or later (the "GPL"), or
the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
in which case the provisions of the GPL or the LGPL are applicable instead
of those above. If you wish to allow use of your version of this file only
under the terms of either the GPL or the LGPL, and not to allow others to
use your version of this file under the terms of the MPL, indicate your
decision by deleting the provisions above and replace them with the notice
and other provisions required by the GPL or the LGPL. If you do not delete
the provisions above, a recipient may use your version of this file under
the terms of any one of the MPL, the GPL or the LGPL.

***** END LICENSE BLOCK *****
*/

var imgNode = "";

function showImageInit( e )
{
	var menu = document.getElementById( "contentAreaContextMenu" );
	menu.addEventListener( "popupshowing", showImageContext, false );
	return;
}

function showImageContext( e )
{
	var prefService = Components.classes[ "@mozilla.org/preferences-service;1" ]
	                            .getService( Components.interfaces.nsIPrefBranch );
	document.getElementById( "show-image" ).hidden = true;
	document.getElementById( "reload-image" ).hidden = true;
	if( gContextMenu.onImage )
	{
		if( ( !gContextMenu.target.naturalWidth ) || ( !gContextMenu.target.complete ) )
		{
			document.getElementById( "show-image" ).hidden = false;
		}
		else if( prefService.getBoolPref( "extensions.showimage.display_reload_image_context_menu" ) == true )
		{
			document.getElementById( "reload-image" ).hidden = false;
		}
	}
	imgNode = gContextMenu.target;
	return;
}

function performShowImage( reload )
{
	var prefService = Components.classes[ "@mozilla.org/preferences-service;1" ]
	                            .getService( Components.interfaces.nsIPrefBranch );
	var oriImageBehavior = 0;
	if( prefService.getIntPref( "permissions.default.image") != 0 )
	{
		oriImageBehavior = prefService.getIntPref( "permissions.default.image" );
        prefService.setIntPref( "permissions.default.image", 0 );
    }
	var imgSrc = imgNode.getAttribute( "src" );
	imgNode.setAttribute( "src","" );
	if( reload == true )
	{
		var imgURI = imgNode.currentURI;
		var imageCacheService = Components.classes[ '@mozilla.org/image/cache;1' ]
		                                  .getService( Components.interfaces.imgICache );
		imageCacheService.removeEntry( imgURI );
	}
	imgNode.setAttribute( "src", imgSrc );
	if( oriImageBehavior != 0 )
	{
        prefService.setIntPref( "permissions.default.image", oriImageBehavior );
	}
	return;
}

window.addEventListener("load", showImageInit, false);
